mod Ex08 logic: 'cl'

incl Mtex

incl Mtexrc

incl Mtexxpr

incl Maux

incl Mxprf

incl Mxprt

loc rem 
  \para \bf  8. CVICENIE Z PREDMETU 1-AIN-625 UVOD DO MATEMATICKEJ LOGIKY PRE 
  PROGRAMATOROV  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.19 
  \para* \it  Datum:  \end utorok 16.11.2010 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-AIN-625-lpp/1011zs/?lang=sk 
  \para* \it  Kontakt:  \end Jan.Komara(at)fmph.uniba.sk 

loc rem 
  \para \bf  Uvodna poznamka.  \end Toto cvicenie je venovane obecne rekurzivnym 
  fukciam (univerzalna funkcia pre p.r. funkcie). Zadanie sa sklada z tychto 
  suborov: z tychto suborov: 
  \items 
   \item \para Subor(y) \it  mtex*.cl  \end obsahuje makra pre CL-TeX. 
   \item \para Subor(y) \it  maux*.cl  \end obsahuje definicie niektorych 
         funkcii a predikatov. 
   \item \para Subor \it  mxprf.cl  \end obsahuje aritmetizaciu p.r. funkcnych 
         symbolov. 
   \item \para Subor \it  mxprt.cl  \end obsahuje aritmetizaciu p.r. termov. 
   \item \para Subor(y) \it  ex*.cl  \end obsahuje ulohy, ktore mate riesit na 
         tomto cviceni. 
   \item \para Subor \it  msyntax.cl  \end obsahuje syntax systemu CL. 
  \end
  \para Tieto subory sa musia skompilovat v spravnom poradi; presny postup je 
  uvedeny v subore \it  readme.txt  \end. 

loc rem 
  \para \bf  Hodnotenie.  \end 
  \items 
   \item \para Pocet bodov za ulohy v tomto subore: 4 
   \item \para Pocet bodov za premiove ulohy v tomto subore: 2 
  \end
  \para Odovzdat do 22.11.2010 (pondelok) do 12:00. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end Downloadable lecture notes available through the 
         web page of the course. 
   \item \para \it  [2]  \end J. Komara and P. J. Voda. Lecture Notes in Theory 
         of Computability. 2001. 
   \item \para \it  [3]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
  \end

rem 
  \para \bf  [CL] CL-TeX.  \end 

appldisp/3 Tex3_appl_sb_dotsc
  Prefix(90,2,Arg(0),
         Fenced(Op('[',0),Infix(Arg(1),30,3,Id(1,',...,',0),Arg(2)),Op(']',0)))

appldisp/0 Tex_f0_m
  Std('m',0)

rem 
  \para \bf  Section. General Recursive Functions.  \end See [1]. 

rem 
  \para \bf  Section. Beyond Primitive Recursion: Universal Function for 
  Primitive Recursive Functions.  \end 

rem 
  \para \bf  Subsection. Arithmetization.  \end. See also the module \it  Mxprf 
   \end. 

rem 
  \para \bf  Arithmetization of primitive recursive function symbols.  \end 

rem 
  \para \bf  Interpreter of primitive recursive function symbols.  \end 

rem 
  \para \bf  Subsection. Primitive Recursive Indices.  \end See also the module 
  \it  Mxprf  \end. 

rem 
  \para \bf  Subsubsection. Effective operations on primitive recursive indices. 
   \end 

rem 
  \para \bf  Exercise.  \end \header* fun Xc1 'Tex_f1_xpr_xc1' \end Define the 
  p.r. function \ft Xc1(m) \end such that 
  \eq* 
    Prf(1,Xc1(m))
  \end
  \eq* 
    Interpreter(Xc1(m),x) = m
  \end

fun Xc1 'Tex_f1_xpr_xc1'
  Xc1(m) = Foo

thm Spec_xc1
  Interpreter(Xc1(m),x) = m

rem 
  \para \bf  Exercise. \it  (1 point)  \end  \end 
  \header* fun/2 Xc2 'Tex_f2_xpr_xc2' \end Define the binary p.r. function 
  \ft Xc2(n,m) \end such that for every \ft n >= 1 \end: 
  \eq* 
    Prf(n,Xc2(n,m))
  \end
  \eq* 
    Interpreter(Xc2(n,m),x1,Tex0_dotsc,Tex2_sub(x,n)) = m
  \end

fun/2 Xc2 'Tex_f2_xpr_xc2'
  Xc2(n,m) = Foo

thm Spec_xc2_1
  Interpreter(Xc2(1,m),x1) = m

thm Spec_xc2_2
  Interpreter(Xc2(2,m),x1,x2) = m

thm Spec_xc2_3
  Interpreter(Xc2(3,m),x1,x2,x3) = m

rem 
  \para \bf  Primitive recursive terms.  \end 

rem 
  \para \bf  Arithmetization of primitive recursive terms.  \end See also the 
  module \it  Mxprt  \end. 

rem 
  \para \bf  Denotation of primitive recursive terms.  \end 

fun/3 Den 'Tex_f3_xpr_den'
  Den(n,Vt(i),v) = Proj(n,v,i)
  Den(n,Ct(m),v) = m
  Den(n,Pt(t,ts),v) = Den(n,t,v),Den(n,ts,v)
  Den(n,At(f,ts),v) = Interpreter(f,Den(n,ts,v))

rem 
  \para \bf  Exercise. \it  (bonus 1 point)  \end  \end 
  \header* fun/2 Xedf 'Tex_f2_xpr_xedf' \end Define the binary p.r. function 
  \ft Xedf(n,t) \end such that 
  \items 
   \item \para for every \ft n >= 1 \end, if the number \ft t \end is the code 
         of a p.r. term \ft Tex3_appl_sb_dotsc(Tex0_tau,x1,Tex2_sub(x,n)) \end 
         with all its free variables indicated then the application 
         \ft Xedf(n,t) \end yields a well-formed p.r. index of the n-ary p.r. 
         function \ft Tex_f0_f \end explicitly defined by 
         \eq* 
           Tex_f3_f(x1,Tex0_dotsc,Tex2_sub(x,n)) = 
           Tex3_appl_sb_dotsc(Tex0_tau,x1,Tex2_sub(x,n))
         \end
         \para or equivalently, we wish to have 
         \eq* 
           Prf(n,Xedf(n,t))
         \end
         \eq* 
           Interpreter(Xedf(n,t),v) = Den(n,t,v)
         \end
         \para for every \ft n \end-tuple \ft v \end. 
  \end
  \para \it  Remark.  \end You will need the unary p.r. function \ft Ar(e) \end 
  yielding the arity of p.r. function symbols. The function is defined in the 
  module \it  Mprf  \end. 

fun/2 Xedf 'Tex_f2_xpr_xedf'
  Xedf(n,t) = Foo

rem 
  \para \bf  Exercise.  \end Find well-formed p.r. indices of \ft x+y \end, 
  \ft x*y \end and \ft Tex_f2_n_exp(x,y) \end. Define the indices with the help 
  of \ft Xedf(n,t) \end. 

fun/0 Xplus 'Tex_f0_xpr_xplus'
  Xplus = Foo

thm Spec_xplus
  Interpreter(Xplus,x,y) = x+y

fun/0 Xtimes 'Tex_f0_xpr_xtimes'
  Xtimes = Foo

thm Spec_xtimes
  Interpreter(Xtimes,x,y) = x*y

fun/0 Xexp 'Tex_f0_xpr_xexp'
  Xexp = Foo

thm Spec_xexp
  Interpreter(Xexp,x,y) = Exp(x,y)

rem 
  \para \bf  Exercise.  \end \header* fun Xiter 'Tex_f1_xpr_xiter' \end Define a 
  p.r. function \ft Xiter(e) \end such that 
  \eq* 
    Prf(1,e) -> Prf(2,Xiter(e))
  \end
  \eq* 
    Interpreter(Xiter(e),0,x) = x
  \end
  \eq* 
    Interpreter(Xiter(e),n+1,x) = Interpreter(e,Interpreter(Xiter(e),n,x))
  \end
  \para This means that if \ft e \end is a p.r. index of a unary function then 
  \ft Xiter(e) \end is a p.r. index of its unary iteration. 

fun Xiter 'Tex_f1_xpr_xiter'
  Xiter(e) = Foo

thm Spec_xiter_zero
  Interpreter(Xiter(e),0,x) = x

thm Spec_xiter_succ
  Interpreter(Xiter(e),n+1,x) = Interpreter(e,Interpreter(Xiter(e),n,x))

rem 
  \para \bf  Exercise. \it  (1 point)  \end  \end Find a well-formed p.r. index 
  of \ft x+y \end which corresponds to the p.r. derivation of addition as an 
  iteration of the successor function. Define the index with the help of 
  \ft Xiter(e) \end. 

fun/0 Xplus2 'Tex_f0_xpr_xplus'
  Xplus2 = Foo

thm Spec_xplus2
  Interpreter(Xplus2,x,y) = x+y

rem 
  \para \bf  Exercise.  \end \header* fun/2 Xrec0 'Tex_f2_xpr_xrec0' \end Define 
  a p.r. function \ft Xrec0(m,e) \end such that 
  \eq* 
    Prf(2,e) -> Prf(1,Xrec0(m,e))
  \end
  \eq* 
    Interpreter(Xrec0(m,e),0) = m
  \end
  \eq* 
    Interpreter(Xrec0(m,e),x+1) = Interpreter(e,x,Interpreter(Xrec0(m,e),x))
  \end
  \para \header* fun F 'Tex_f1_f' \end \header* fun/2 H1 'Tex_f2_h' \end 
  \header* fun/0 M1 'Tex_f0_m' \end This means that if \ft M1 \end is a constant 
  and \ft e \end is a p.r. index of a binary function \ft H1(x,a) \end then 
  \ft Xrec0(m,e) \end is a p.r. index of the unary function \ft F(x) \end 
  defined by following parameterless primitive recursion: 
  \def 
    fun F 'Tex_f1_f'
    F(0) = M1
    F(x+1) = H1(x,F(x))
  \end

fun/2 Xrec0 'Tex_f2_xpr_xrec0'
  Xrec0(m,e) = Foo

thm Spec_xrec0_zero
  Interpreter(Xrec0(m,e),0) = m

thm Spec_xrec0_succ
  Interpreter(Xrec0(m,e),x+1) = Interpreter(e,x,Interpreter(Xrec0(m,e),x))

rem 
  \para \bf  Exercise. \it  (1 point)  \end  \end 
  \header* fun/0 Xsum 'Tex_f0_xpr_xsum' \end Find a well-formed p.r. index of 
  \ft Sum(n) \end which corresponds to the derivation of the summation function 
  by parameterless recursion. Define the index with the help of 
  \ft Xrec0(m,e) \end. 

fun/0 Xsum 'Tex_f0_xpr_xsum'
  Xsum = Foo

thm Spec_xsum
  Interpreter(Xsum,n) = Sum(n)

rem 
  \para \bf  Exercise.  \end Find a well-formed p.r. index of \ft x-1 \end which 
  corresponds to the derivation of the predecessor function by parameterless 
  recursion. Define the index with the help of \ft Xrec0(m,e) \end. 

fun/0 Xpred 'Tex_f0_xpr_xpred'
  Xpred = Foo

thm Spec_xpred
  Interpreter(Xpred,x) = x-1

rem 
  \para \bf  Exercise. \it  (1 point)  \end  \end Find a well-formed p.r. index 
  of \ft x-y \end which corresponds to the p.r. derivation of modified 
  subtraction as an iteration of the predecessor function. Define the index with 
  the help of \ft Xiter(e) \end. 

fun/0 Xminus 'Tex_f0_xpr_xminus'
  Xminus = Foo

thm Spec_xminus
  Interpreter(Xminus,x,y) = x-y

rem 
  \para \bf  Exercise.  \end \header* fun/2 Xparam 'Tex_f2_xpr_xparam' \end 
  Define the binary \it  parametric  \end function \ft Xparam(e,x) \end such 
  that 
  \eq* 
    Prf(2,e) -> Prf(1,Xparam(e,x))
  \end
  \eq* 
    Interpreter(Xparam(e,x),y) = Interpreter(e,x,y)
  \end
  \para as a p.r. function. 

fun/2 Xparam 'Tex_f2_xpr_xparam'
  Xparam(e,x) = Foo

thm Spec_xparam
  Interpreter(Xparam(e,x),y) = Interpreter(e,x,y)

rem 
  \para \bf  Exercise. \it  (bonus 1 point)  \end  \end 
  \header* fun/3 Xsmn_2_3 'Tex_f3_xpr_xsmn_2_3' \end Prove the \it  Kleene's 
  s-m-n theorem  \end for the case \ft m = 2 \end and \ft n = 3 \end by 
  providing a ternary p.r. function \ft Xsmn_2_3(e,x1,x2) \end such that 
  \eq* 
    Prf(5,e) -> Prf(3,Xsmn_2_3(e,x1,x2))
  \end
  \eq* 
    Interpreter(Xsmn_2_3(e,x1,x2),y1,y2,y3) = Interpreter(e,x1,x2,y1,y2,y3)
  \end

fun/3 Xsmn_2_3 'Tex_f3_xpr_xsmn_2_3'
  Xsmn_2_3(e,x1,x2) = Foo

thm Spec_xsmn_2_3
  Interpreter(Xsmn_2_3(e,x1,x2),y1,y2,y3) = Interpreter(e,x1,x2,y1,y2,y3)

loc rem 
  ******************************************************************************
  ********************************* DEBUGGING **********************************
  ******************************************************************************

loc fun Test_fun 
  Test_fun(x) = Foo

loc fun/2 Itfa 
  Itfa(0,a) = a
  Itfa(n+1,a) = Itfa(n,(n,Test_fun(n)),a)

loc fun Itf 
  Itf(n) = Itfa(n,0)

loc pred Test_pred 
  Test_pred(x) <-> Poo

loc fun/2 Itpa 
  Itpa(0,a) = a
  Itpa(n+1,a) = Itpa(n,n,a) <- Test_pred(n)
  Itpa(n+1,a) = Itpa(n,a) <- ~Test_pred(n)

loc fun Itp 
  Itp(n) = Itpa(n,0)

